package cn.csdn.activity;

import android.content.ContentProvider;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.UriMatcher;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.net.Uri;
import cn.csdn.service.DatabaseHelper;

public class UserContentProvider extends ContentProvider {
	private DatabaseHelper helper;
	private SQLiteDatabase db;
	private static UriMatcher matcher = new UriMatcher(UriMatcher.NO_MATCH);
	private static final int USERS = 1;
	private static final int USER = 2;
	static{
		matcher.addURI("cn.csdn.activity.providers.userprovider", "user", USERS);
		matcher.addURI("cn.csdn.activity.providers.userprovider", "user/#", USER);
	}
	public int delete(Uri uri, String selection, String[] selectionArgs) {
		db=helper.getWritableDatabase();
		int num=0;
		switch(matcher.match(uri)){
		case USERS:
			num=db.delete("user", selection, selectionArgs);
			break;
		case USER:
			long id=ContentUris.parseId(uri);
			String where="id="+id;
			if(selection!=null&&!"".equals(selection)){
				where=where+" and "+selection;
			}
			num=db.delete("user", where, selectionArgs);
			break;
		default:
			throw new IllegalArgumentException("Unknown Uri:"+ uri);
		}
		return num;
	}

	public String getType(Uri uri) {
		switch(matcher.match(uri)){
		case USERS:
			return "vnd.android.cursor.dir/person";
		case USER:
			return "vnd.android.cursor.item/person";
		default:
			throw new IllegalArgumentException("Unknown Uri:"+ uri);
		}
	}

	public Uri insert(Uri uri, ContentValues values) {
		db=helper.getWritableDatabase();
		long rowid;
		switch(matcher.match(uri)){
		case USERS: //¼¼к
			rowid=db.insert("user", "id", values);
			return ContentUris.withAppendedId(uri, rowid);
		default:
			throw new IllegalArgumentException("Unknow Uri:" + uri);
		}		
	}

	public boolean onCreate() {
		helper=new DatabaseHelper(this.getContext(),"users.db");
		return true;
	}

	public Cursor query(Uri uri, String[] projection, String selection,
			String[] selectionArgs, String sortOrder) {
		db = helper.getReadableDatabase();
		switch(matcher.match(uri)){
		case USERS:
			return db.query("user", projection, selection, selectionArgs, null, null, sortOrder);
		case USER:
			long id=ContentUris.parseId(uri);
			String where="id="+id;
			if(selection!=null&&!"".equals(selection)){
				where=where+" and "+selection;
			}
			return db.query("user", projection, where, selectionArgs, null, null, sortOrder);
		default:
			throw new IllegalArgumentException("Unknown Uri:"+ uri);
		}
	}

	public int update(Uri uri, ContentValues values, String selection,
			String[] selectionArgs) {
		db=helper.getWritableDatabase();
		int num;
		switch(matcher.match(uri)){
		case USERS:
			num=db.update("user", values, selection, selectionArgs);
			break;
		case USER:
			long id=ContentUris.parseId(uri);
			String where="id="+id;
			if(selection!=null&&!"".equals(selection)){
				where=where+" and "+selection;
			}
			num=db.update("user", values, selection, selectionArgs);
			break;
		default:
			throw new IllegalArgumentException("Unknow Uri"+uri);
		}
		return num;
	}
}
